<?php
/**
 * The core componant of phpUserTrack. This brings all the libraries together.
 * @author Christopher Troup <mini@chatetheory.com>
 * @package phpUserTrack
 */

require_once 'libExceptions.php';

/**
 * Gets the system time in high resolution
 *
 * @return int System Time
 */
function getmicrotime() {
	list($usec, $sec) = explode(" ",microtime());
	return ((float)$usec + (float)$sec);
}
$time = getmicrotime();

header('P3P: CP="CAO PSA OUR"');
session_set_cookie_params (60 * 60 * 24 * 365, '/');
session_start();
ob_start("ob_gzhandler");


putenv("TZ=" . $conf['timezone']);

/**
 * Include login files
 */
require_once 'liblogin.php';

/**
 * Include useragent detection library.
 */
require_once 'libdetectuseragent.php'; // Browser detection alogorithm

/**
 * Include database access functions.
 */
require_once 'libsite.php';
require_once 'libdata.php';
require_once 'libip.php';

/**
 * Include the plugin architecture.
 */
require_once 'libplugins.php';


/**
 * Include the configuration file.
 */
if (!@include_once (dirname(__FILE__) . '/../conf/conf.php')) {
	header( 'Location: install.php' ) ;
}

/**
 * Check to see if they have GeoIP installed. If they do record the fact for future use.
 */
if (@include_once 'Net/GeoIP.php') {
	$geoIP = file_exists(dirname(__FILE__) . '/../include/GeoLiteCity.dat');
} else {
	$geoIP = false;
}

if (@include_once 'Cache/Lite.php') {
	$cache = true;
} else {
	$cache = false;
}

$plugins = new plugins(); // create a new instance of the plugin class

/**
 * Preform the tracking of the user who requested the page.
 * @global array $conf
 * @global plugins $plugins
 */
function phpUserTrack($site_id = null, $path = null, $refferrer = null) {
	global $conf;
	global $plugins;

	$ip = $_SERVER['REMOTE_ADDR'];

	// ip.pre hook
	$ipCon = new phpusertrack_ip($ip);
	foreach ($plugins->hooks['ip.pre'] as $obj) {
		$ipCon = $obj->invoke($ipCon);
	}
	if ($ipCon != null) {
		$path = $_SERVER['REQUEST_URI'];
		if ($ipCon->getProfileId() == null) {
			$agent =  new detectUserAgent();
			$browserArray = $agent->getBrowserArray();
			$ipCon->insertProfile($browserArray['browser'],
			$browserArray['version'],
			$browserArray['platform']);
		}

		// ip.post hook
		foreach ($plugins->hooks['ip.post'] as $obj) {
			$ipCon = $obj->invoke($ip);
		}
		// data.pre hook
		//$sql = 'select id from phpusertrack_sites where id like %' . $_GET['server'];
		//$site_id = $db->_query($sql);
		//$site_id = $site_id[0];
		
		$dataCon = new phpusertrack_data($site_id, $ipCon->getProfileId(), $path, $_SERVER['HTTP_REFERER']);
		foreach ($plugins->hooks['data.pre'] as $obj) {
			$dataCon = $obj->invoke($dataCon);
		}
		$dataCon->insertNewPageHit();
		// data.post hook
		foreach ($plugins->hooks['data.post'] as $obj) {
			$dataCon = $obj->invoke($dataCon);
		}
	}
}

?>
